//ak47.cs

//audio
datablock AudioProfile(ak47Shot1Sound)
{
   filename    = "./ak47-1.wav";
   description = AudioClose3d;
   preload = true;
};



datablock ParticleData(ak47FlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 18;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 1.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.5 0.0 0.9";

	sizes[0]      = 0.8;


	useInvAlpha = false;
};
datablock ParticleEmitterData(ak47FlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ak47FlashParticle";
};

//shell
datablock DebrisData(ak47ShellDebris)
{
	shapeFile = "./gunShell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};













AddDamageType("ak47",   '<bitmap:add-ons/weapon_ak47/CI_ak47> %1',    '%2 <bitmap:add-ons/weapon_ak47/CI_ak47> %1',0.5,1);
datablock ProjectileData(ak47accProjectile)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 40;
   directDamageType    = $DamageType::ak47;
   radiusDamageType    = $DamageType::ak47;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 1;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = GunExplosion;
   //particleEmitter     = bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   

};
AddDamageType("ak47",   '<bitmap:add-ons/weapon_ak47/CI_ak47> %1',    '%2 <bitmap:add-ons/weapon_ak47/CI_ak47> %1',0.5,1);
datablock ProjectileData(ak47spreadProjectile)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 5;
   directDamageType    = $DamageType::ak47;
   radiusDamageType    = $DamageType::ak47;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 1;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = GunExplosion;
   //particleEmitter     = bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   

};
AddDamageType("ak47",   '<bitmap:add-ons/weapon_ak47/CI_ak47> %1',    '%2 <bitmap:add-ons/weapon_ak47/CI_ak47> %1',0.5,1);
datablock ProjectileData(ak47killProjectile)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 50;
   directDamageType    = $DamageType::ak47;
   radiusDamageType    = $DamageType::ak47;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 1;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = GunExplosion;
   //particleEmitter     = bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   

};

//////////
// item //
//////////
datablock ItemData(ak47Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./ak47.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Ak47";
	iconName = "./ci_ak47";
	doColorShift = false;
	colorShiftColor = "0.2 0.2 0.2 1.000";

	 // Dynamic properties defined by the scripts
	image = ak47Image;
	canDrop = true;
};




datablock ShapeBaseImageData(ak47Image)
{
   // Basic Item properties
   shapeFile = "./ak47.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = ak47spreadProjectile;
   projectileType = Projectile;

	casing = ak47ShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = False;
   colorShiftColor = ak47Item.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
// Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.0;
	stateTransitionOnTimeout[0]       = "Ready";

	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "smoke";
    stateTimeoutValue[2]            = 0.098;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= ak47FlashEmitter;
	stateEmitterTime[2]				= 0.06;
	stateEjectShell[2]       	  = true;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= ak47Shot1Sound;
    stateSequence[2]                = "Fire";
	stateEjectShell[2]       = true;

	






	stateName[3] = "Smoke";

	stateTimeoutValue[3]            = 0.04;
		stateWaitForTimeout[3]			= true;
    stateTransitionOnTriggerUp[3]     = "reload";
    stateTransitionOnTriggerdown[3]     = "fire2";
		
		
			stateName[4]                    = "Fire2";
	stateTransitionOnTimeout[4]     = "smoke";
   stateTimeoutValue[4]            = 0.098;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                 = "Fire";
	stateScript[4]                  = "onFiretwos";
	stateWaitForTimeout[4]			= true;
	stateEmitter[4]					= ak47FlashEmitter;
	stateEmitterTime[4]				= 0.15;
	stateEjectShell[4]       	  = true;
	stateEmitterNode[4]				= "muzzleNode";
	stateSound[4]					= ak47Shot1Sound;
    stateSequence[4]                = "Fire";
	stateEjectShell[4]       = true;
		
		



	stateName[5]			= "Reload";
	stateAllowImageChange[5]        = false;
	stateTimeoutValue[5]            = 0.1;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "Reload";
	stateTransitionOnTimeout[5]     = "ready";
	//stateTransitionOnTriggerUp[5]     = "Ready";

	

	



};


//exec("add-ons/weapon_ak47.cs");

function ak47Image::onFire(%this,%obj,%slot)
{

	%projectile = ak47accprojectile;
	%spread = 0.0001;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}	




function ak47Image::onFiretwos(%this,%obj,%slot)
{

	

	%projectile = ak47spreadprojectile;
	%spread = 0.009;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}













